<!DOCTYPE html>
<html>
	<head>
		<base target="_top">
		<link rel="stylesheet" href="https://ssl.gstatic.com/docs/script/css/add-ons1.css">    
    <?!= HtmlService.createHtmlOutputFromFile('Stylesheet').getContent(); ?>

    <script>
      function startAuthentication() {
        document.getElementById('startLoginButton').classList.remove('blue');
        document.getElementById('startLoginButton').value = 'Return to login';
        document.getElementById('confirmLoginButton').classList.add('blue');

        const newWindow = window.open('https://programaker.com/authorize'
          + '?response_type=token'
          + '&scope=list_custom_blocks+list_connections_established+call_any_bridge'
          + '&state=' + ((new Date()).getTime()),
        "Login to PrograMaker");

        if (window.focus) {
          newWindow.focus();
        }
      }

      function finishAuth() {
        startLoading();
        const loginCode = document.getElementById('loginCode').value;
        google.script.run.finishLogin(loginCode);
      }

      function startLogout() {
        startLoading();
        google.script.run.logout();
      }
      
      function updateCommand(span_id, input) {
        document.getElementById(span_id).innerText = `"${input.value}"`;
      }
      
      function startLoading() {
        document.body.classList.add("loading");
        const buttons = document.querySelectorAll('[type="button"]');
        for (let i = 0; i < buttons.length; i++) {
          buttons[i].setAttribute('disabled', 'true');
        }
      }
      
      function toggleShownBridge(bridge_id) {
        const div = document.getElementById("bridge-" + bridge_id);
        const classes = div.classList;
        if (classes.contains('collapsed')) {
          classes.remove('collapsed');
        }
        else {
          classes.add('collapsed');
        }
      }
    </script>
	</head>
	<body>
      <div class="loading-indicator"><div class="progress"></div></div>
      <? if (error) { ?>
        <div class="error error-description">
          <?= error ?>
        </div>
      <? } ?>
      
    <? if (!logged) { ?>
      <br />
      <center>
        <!-- NOTE THAT This will fail if our user is not the first GoogleApps account. 
        See: https://stackoverflow.com/a/60522632
        See: https://github.com/burnnat/page-sizer/issues/3
        -->
        <input class="blue" 
        id="startLoginButton"
         type="button"
          value="Login"
        onclick="startAuthentication()" />

        <input type="button" onclick="startLoading();google.script.run.openPanel()" value="Reload" />

        <br/><br/>
        <form>
          <input type='text' id="loginCode" placeholder="Fill here the authentication code" /><br/>
          <input
            id="confirmLoginButton"
            type="button"
            value="Authenticate"
            onclick="finishAuth()" />
        </form>

      </center>
        <h3 align="center">How to use this add-on</h3>
        <ol>
          <li>Click "Login" to identify as a PrograMaker user.<br>
            This will open a new browser tab, there you can confirm that you want to identify as an user.</li>
          <li>To confirm click on "Generate token". This will generate an authorization code.</li>
          <li>To complete the login, come back to this tab and introduce the authorization code from the web.</li>
        </ol>
    <? } else { ?>

      <center>
        <br />
        <input class="red" 
          id="startLogoutButton"
          type="button"
          value="Logout"
          onclick="startLogout()" />

        <input type="button" onclick="startLoading();google.script.run.refresh()" value="Reload" />
      </center>

      <ol>
        <li>Click on the service you want to connect to.</li>
        <li>Fill the fields with the data you want to obtain.</li>
        <li>Copy the <span class="code">formula</span> to a cell.</li>
      </ol>
      <hr/>
      <? for (const service of services) {
        const service_blocks = blocks[service.bridge_id].filter(b => b.block_type === 'getter');
        if (service_blocks.length === 0) { continue; }
        ?>
        <div class="collapsed bridge" id="bridge-<?= service.bridge_id ?>">
          <h3 onclick="toggleShownBridge('<?= service.bridge_id ?>')"><?!= service.bridge_name ?></h3>
          <div class="contents">
            <? for (const block of service_blocks) { 
              const block_id = block.function_name + '_' + service.bridge_id.substr(0,4);
            ?>
            
              <div class="function-name">
                <?!= block.message.replace(/%(\d+)/g, (substr) => buildInputForArgument(block_id, block, substr, service.bridge_id)) ?>
                <?!= buildLeftOverArguments(block_id, block, service.bridge_id) ?>
              </div>

              <div class="code"><?!=
              '=PRMKR(<span class="formula-argument">"' + block_id + '"</span>' 
              + block.arguments.map((v, i) => `, <span class="formula-argument" id="${block_id}_${i + 1}">""</span>`).join('')
              + ')'
              ?></div>
                
            <? } ?>
          </div>
        </div>
      <? } ?>

    <? } ?>
		<br><br>

	</body>
</html>
